//***********
// PMDf
//***********

#ifndef	_PMDMODEL_H_
#define	_PMDMODEL_H_

#include	"PMDTypes.h"
#include	"PMDBone.h"
#include	"PMDIK.h"
#include	"PMDFace.h"
#include	"MotionPlayer.h"

class cPMDModel
{
	private :
		char			m_szModelName[21];	// f

		unsigned long	m_ulNumVertices;	// _

		Vector3			*m_pvec3OrgPositionArray;	// Wz
		Vector3			*m_pvec3OrgNormalArray;		// @z
		TexUV			*m_puvOrgTexureUVArray;		// eNX`Wz

		struct SkinInfo
		{
			float			fWeight;		// EFCg
			unsigned short	unBoneNo[2];	// {[ԍ
		};
		SkinInfo		*m_pOrgSkinInfoArray;

		Vector3			*m_pvec3PositionArray;
		Vector3			*m_pvec3NormalArray;

		unsigned long	m_ulNumIndices;		// _CfbNX
		unsigned short	*m_pIndices;		// _CfbNXz

		struct Material
		{
			Color4			col4Diffuse,
							col4Specular,
							col4Ambient;
			float			fShininess;

			unsigned long	ulNumIndices;
			unsigned int	uiTexID;		// eNX`ID
		};
		unsigned long	m_ulNumMaterials;	// }eA
		Material		*m_pMaterials;		// }eAz

		unsigned short	m_unNumBones;		// {[
		cPMDBone		*m_pBoneArray;		// {[z

		cPMDBone		*m_pNeckBone;		// ̃{[
		bool			m_bLookAt;			// ^[Qbg֌邩ǂ

		unsigned short	m_unNumIK;			// IK
		cPMDIK			*m_pIKArray;		// IKz

		unsigned short	m_unNumFaces;		// \
		cPMDFace		*m_pFaceArray;		// \z

		cMotionPlayer	m_clMotionPlayer;

	public :
		cPMDModel( void );
		~cPMDModel( void );

		bool load( const char *szFilePath );
		bool initialize( unsigned char *pData );

		cPMDBone *getBoneByName( const char *szBoneName );
		cPMDFace *getFaceByName( const char *szFaceName );

		void setMotion( cVMDMotion *pVMDMotion, bool bLoop = false, float fInterpolateFrame = 0.0f );
		bool updateMotion( float fElapsedFrame );
		void updateNeckBone( const Vector3 *pvec3LookTarget, float fLimitXD = -20.0f, float fLimitXU = 45.0f, float fLimitY = 80.0f );
		void updateSkinning( void );

		void render( void );
		void renderForShadow( void );

		void release( void );

		inline void toggleLookAtFlag( void ){ m_bLookAt = !m_bLookAt; } 
		inline void setLookAtFlag( bool bFlag ){ m_bLookAt = bFlag; } 

		inline const char *getModelName( void ){ return m_szModelName; } 

	friend class cMotionPlayer;
};

#endif	// _PMDMODEL_H_
